/*
**==============================================================================
**
** Open Management Infrastructure (OMI)
**
** Copyright (c) Microsoft Corporation
** 
** Licensed under the Apache License, Version 2.0 (the "License"); you may not 
** use this file except in compliance with the License. You may obtain a copy 
** of the License at 
**
**     http://www.apache.org/licenses/LICENSE-2.0 
**
** THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
** KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED 
** WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, 
** MERCHANTABLITY OR NON-INFRINGEMENT. 
**
** See the Apache 2 License for the specific language governing permissions 
** and limitations under the License.
**
**==============================================================================
*/

#include <stdlib.h>
#include <string.h>
#include "strarr.h"
#include "strings.h"

char** StrArr()
{
    return (char**)calloc(1, sizeof(char*));
}

void StrArrCat(char*** self_, const char* str)
{
    size_t len;
    char** self = *self_;
    
    len = StrArrLen(self);
    self = (char**)realloc(self, sizeof(char*) * (len + 2));

    if (self)
    {
        char* s = Strdup(str);
        self[len] = s;
        self[len+1] = NULL;
    }

    *self_ = self;
}

size_t StrArrLen(char** self)
{
    char** p = self;

    while (*p)
        p++;

    return p - self;
}

void StrArrFree(char** self)
{
    char** p = self;
    while (*p)
        free(*p++);

    free(self);
}

wchar_t** WcsArr()
{
    return (wchar_t**)calloc(1, sizeof(wchar_t*));
}

void WcsArrCat(wchar_t*** self_, const wchar_t* str)
{
    size_t len;
    wchar_t** self = *self_;
    
    len = WcsArrLen(self);
    self = (wchar_t**)realloc(self, sizeof(wchar_t*) * (len + 2));

    if (self)
    {
        wchar_t* s = Wcsdup(str);
        self[len] = s;
        self[len+1] = NULL;
    }

    *self_ = self;
}

size_t WcsArrLen(wchar_t** self)
{
    wchar_t** p = self;

    while (*p)
        p++;

    return p - self;
}

void WcsArrFree(wchar_t** self)
{
    wchar_t** p = self;
    while (*p)
        free(*p++);

    free(self);
}
